import java.util.*;
import java.io.*;



public class GenPropFile{
	
	String template_file;
	String config_file;
	String adapter;
	
	public void go(String argv[]){
		if(argv.length<3){
			usage();
			System.exit(-1);
		}
		template_file=argv[0];
		config_file=argv[1];
		adapter=argv[2].trim().toUpperCase();
		GenConfigFile();
		
	}
	
	public void GenConfigFile(){
		
			
		System.out.println("Generating: "+config_file);
		System.out.println("Adapter: "+adapter);
		//open files
		BufferedReader cfg_in;
		PrintWriter cfg_out;
		try{
			cfg_in=new BufferedReader(new FileReader(template_file));
			cfg_out=new PrintWriter(new FileWriter(config_file));
			
			if(adapter.equals("UDP"))
				cfg_out.println("Node=SPT\n"+
								"SocketAdapter = ScktAdptUDP\n"+
								"ScktAdptUDP.MessageBufferSize = 2048\n");
			else if(adapter.equals("TCP"))
				cfg_out.println("Node=SPT\n"+
								"SocketAdapter = ScktAdptTCP\n");
			else if(adapter.equals("FLOODSPT"))
				cfg_out.println("Node=SPT\n"+
								"SocketAdapter= ScktAdptFlood\n"+
								"ScktAdptUDPMulticast.UDPMulticastAddress= 224.228.19.78/9473\n"+
								"ScktAdptUDPMulticast.MessageBufferSize = 4096\n");
			
			else if(adapter.equals("FLOOD"))
				cfg_out.println("Node=FLOOD\n"+
								"SocketAdapter= ScktAdptUDPMulticast\n"+
								"ScktAdptUDPMulticast.UDPMulticastAddress= 224.228.19.78/9473\n"+
								"ScktAdptUDPMulticast.MessageBufferSize = 4096\n");
			else //default "MCAST"
				cfg_out.println("Node=SPT\n"+
								"SocketAdapter= ScktAdptUDPMulticast\n"+
								"ScktAdptUDPMulticast.UDPMulticastAddress= 224.228.19.78/9473\n"+
								"ScktAdptUDPMulticast.MessageBufferSize = 4096\n");
								
			cfg_out.println("\n\n");
			
			//copy config template file
			String line=cfg_in.readLine();
			while(line!=null){
				cfg_out.println(line);
				line=cfg_in.readLine();
			}
			
			
			
			cfg_in.close();
			cfg_out.close();
			
			
		}catch (IOException e){
			System.err.println(e);
			System.exit(-2);	
		}
	
		
	}
	
	static public void main(String argv[]){
		GenPropFile gp= new GenPropFile();
		
		
		gp.go(argv);
		
	}
	
	void usage(){
		System.out.println("Usage: java GenPropFile <template_file> <config_file> <adapter>");
		System.out.println("       options of <adapter>: MCAST UDP TCP FLOOD");
		
	}
	
	
	public GenPropFile(){
		
	}
	
}