/* Chesapeake TTCP
 * Copyright 1997, Chesapeake Computer Consultants, Inc.
 */

import java.io.*;
import java.util.Date;
import java.util.StringTokenizer;
import java.util.Vector;

import hypercast.MonitorAndControl.I_Portal;
import hypercast.events.NODE_NEIGHBORHOODCHANGED;
import hypercast.*;

public class ttcp {
	public static void main(String args[]) {
		ttcp run_ttcp = new ttcp();
		run_ttcp.go(args);
	}

	//I_Portal portal;

	public void startMonitorMode(TransThread Trans, String rsfile) {

		int i = 0;
		String arg;
		String rc2 = "none";

		Trans.monitor = true;
		
		HyperCastConfig config= HyperCastConfig.createConfig(rsfile);
		
		//portal = config.createPortal(Trans, "Appl");
		//portal.openPortal();

	}
	
	
	public void go(String args[]) {
		int i = 0, j;
		String arg;
		char flag;
		int prot = ParamsClass.TCP;

		boolean tr = true;
		boolean err = false;
		ParamsClass Params;
		TransThread Trans;
		int bufsize = 0, numbuf = 0, port = 0;
		String host = "";
		String maddr = "";
		String logfile = null;
		String seqfile = null;
		String bwfile = null;
		String delayfile = null;
		String eventfile = null;
		String intercptfile=null;
		
		int bw_period = 0;

		boolean stop = true;
		int repeatTime = 0;

		int start_rate = 0;
		int end_rate = 0;
		int rate_step = 25;

		long time_stamp = System.currentTimeMillis();

		boolean monitor = false;
		String rsfile="RunServerSocket.prop.txt";

		if (args.length == 0) {
			Usage();
			System.exit(1);
		}
		Params = new ParamsClass();
		Params.backupDelayFile = "ttcp_delay_" + time_stamp;

		System.out.println("Overlay TTCP");
		boolean fixKey=false;

		while (i < args.length && args[i].startsWith("-")) {
			arg = args[i++];
			//System.out.println("arg="+arg+";");
			if(arg.equals("-or")){
				//overrides file
				if (i < args.length && !args[i].startsWith("-")) {
					overrides_file=(args[i++]);
				}else
					overrides_file=null;
			}
			else if (arg.equals("-fk")){
				//this one is especially for experiment
				fixKey=true;
			}else if (arg.equals("-monitor")) {
				System.out.println("Start monitor mode");
				monitor = true;
				if (i < args.length && !args[i].startsWith("-")) {
					rsfile=(args[i++]);
				}

			} else if (arg.equals("-prop")) {
				if (i < args.length && !args[i].startsWith("-")) {
					Params.setOLConfig(args[i++]);
				}
			} else if (arg.equals("-l")) { // check arguments - some require parameters
				if (i < args.length && !args[i].startsWith("-")) {
					bufsize = Integer.parseInt(args[i++]);
					if (bufsize < 2) {
						bufsize = 2; //the size of packet is at least 2
						System.out.println("Change the packet size to 2!");
					}
				} else {
					System.err.println("-l requires a buffer length");
					err = true;
				}
			} else if (arg.equals("-n")) {
				if (i < args.length && !args[i].startsWith("-"))
					numbuf = Integer.parseInt(args[i++]);
				else {
					System.err.println("-n requires a number of buffers");
					err = true;
				}
			} else if (arg.equals("-p")) {
				if (i < args.length)
					port = Integer.parseInt(args[i++]);
				else {
					System.err.println("-p requires a port number");
					err = true;
				}
			} else if (arg.equals("-t")) {
				if (i < args.length && !args[i].startsWith("-")) {
					host = args[i++];
					Params.addToHostList(host);
					while (i < args.length && !args[i].startsWith("-")) {
						Params.addToHostList(args[i++]);

					}
				} else if (prot == ParamsClass.MCAST) {
					host = "224.228.19.79";
					System.err.println("multicast destination set to default 224.228.19.79");
				} else if (prot == ParamsClass.OVERLAY) {

				} else {

					System.err.println("-t requires a hostname or address");
					err = true;
				}
				tr = false;
			} else if (arg.equals("-r")) {
				tr = true;
			} else if (arg.equals("-u")) {
				prot = ParamsClass.UDP;
			} else if (arg.equals("-m")) {
				prot = ParamsClass.MCAST;
				if (i < args.length && !args[i].startsWith("-")) {
					maddr = args[i++];

				} else if (tr) {
					maddr = "224.228.19.79";
					System.err.println("multicast address set to default 224.228.19.79");

				}
			} else if (arg.equals("-o")) {
				prot = ParamsClass.OVERLAY;

			} else if (arg.equals("-R")) {
				if (i < args.length && !args[i].startsWith("-")) {
					start_rate = Integer.parseInt(args[i++]);
					if (i < args.length && !args[i].startsWith("-")) {
						end_rate = Integer.parseInt(args[i++]);

						if (i < args.length && !args[i].startsWith("-"))
							rate_step = Integer.parseInt(args[i++]);
						else
							rate_step = 25;
					} else {
						end_rate = start_rate;
						rate_step = 0;
					}

				} else {
					System.err.println("-R requires a sending rate");
					err = true;
				}
			} else if (arg.equals("-h")) {
				Usage();
				System.exit(1);
			} else if (arg.equals("-c")) {
				stop = false;
				if (i < args.length && !args[i].startsWith("-")) {
					repeatTime = Integer.parseInt(args[i++]);

				}

			} else if (arg.equals("-f")) {
				if (i < args.length && !args[i].startsWith("-")) {
					logfile = args[i++];
					eventfile= "EVENT_"+logfile;

				} else {
					logfile = "ttcp_log_" + time_stamp + ".txt";
					eventfile = "ttcp_event_" + time_stamp + ".txt";
				}
				System.err.println("log: " + logfile);
				System.err.println("event: " + eventfile);
			}else if (arg.equals("-int")) {
				if (i < args.length && !args[i].startsWith("-")) {
					intercptfile = args[i++];
					
				} else {
					intercptfile = "ttcp_intercept_" + time_stamp + ".txt";
				}
				System.err.println("intercept: " + intercptfile);
			}  
			
			else if (arg.equals("-s")) {
				if (i < args.length && !args[i].startsWith("-")) {
					seqfile = args[i++];

				} else {
					seqfile = "ttcp_seq_" + time_stamp;

				}
				System.err.println("record sequence number to: " + seqfile);
			} else if (arg.equals("-bw")) {
				if (i < args.length && !args[i].startsWith("-")) {

					bw_period = Integer.parseInt(args[i++]);

					if (i < args.length && !args[i].startsWith("-")) {
						bwfile = args[i++];

					} else if (tr) {
						bwfile = "ttcp_bw_" + time_stamp;

					}
					System.err.println("record bandwidth number to: " + bwfile);
				} else {
					System.err.println("-bw requires a bandwidth checkpoint interval");
					err = true;
				}
			} else if (arg.equals("-d")) {

				if (tr) {
					System.err.println("only transmitter can record delays");
					err = true;
					break;
				}

				if (i < args.length && !args[i].startsWith("-")) {

					delayfile = args[i++];

				} else {
					delayfile = "ttcp_delay_" + time_stamp;

				}
				System.err.println("record delay to: " + delayfile);

			}else if (arg.equals("-s2gap")) {
				String sq_file;
				String gap_file;
				int sq_interval = 50;
				if (i < args.length && !args[i].startsWith("-")) {

					sq_file = (args[i++]);
					gap_file = sq_file + "_GAP.txt";

					if (i < args.length && !args[i].startsWith("-")) {
						gap_file = args[i++];
					}

					sq2Gap(sq_file, gap_file);

					System.exit(1);

				} else {
					System.err.println("-s2gap requires a input file name");
					err = true;
				}
		

			}  
			else if (arg.equals("-s2d")) {
				String sq_file;
				String ds_file;
				int sq_interval = 50;
				if (i < args.length && !args[i].startsWith("-")) {

					sq_interval = Integer.parseInt(args[i++]);

					if (i < args.length && !args[i].startsWith("-")) {

						sq_file = (args[i++]);
						ds_file = sq_file + "_DS.txt";

						if (i < args.length && !args[i].startsWith("-")) {
							ds_file = args[i++];

						}

						sq2Ds_SW(sq_file, ds_file, sq_interval);

						System.exit(1);

					} else {
						System.err.println("-s2d requires a input file name");
						err = true;
					}

				} else {
					System.err.println("-s2d requires a interval number");
					err = true;
				}

			} else if (arg.equals("-d2sw")) {
				String dl_file;
				String dl_sw_file;
				int sq_interval = 50;
				String dest=null;
				if (i < (args.length-1) && !args[i].startsWith("-")) {

					sq_interval = Integer.parseInt(args[i++]);
					dest = args[i++];
					if(dest.equals("none"))dest=null;

					if (i < args.length && !args[i].startsWith("-")) {

						dl_file = (args[i++]);
						dl_sw_file = dl_file + "_SW.txt";

						if (i < args.length && !args[i].startsWith("-")) {
							dl_sw_file = args[i++];
						}

						dl2SW(dl_file, dl_sw_file, sq_interval, dest);

						System.exit(1);

					} else {
						System.err.println("-d2sw requires a input file name");
						err = true;
					}

				} else {
					System.err.println("-d2sw requires a interval number and destination");
					err = true;
				}

			} else if (arg.equals("-s2bw")) {
				String sq_file;
				String ds_file;
				int buf_size = 512;
				//int buf_size = 2048;
				//int buf_size = 4096;
				//int buf_size = 8192;
				//int buf_size = 10240;
				int sq_interval = 50;
				if (i < args.length && !args[i].startsWith("-")) {

					sq_interval = Integer.parseInt(args[i++]);

					if (i < args.length && !args[i].startsWith("-")) {

						sq_file = (args[i++]);
						ds_file = sq_file + "_BW.txt";

						if (i < args.length && !args[i].startsWith("-")) {
							ds_file = args[i++];

						}

						if (i < args.length && !args[i].startsWith("-")) {
							buf_size = Integer.parseInt(args[i++]);
						}

						sq2BW_SW(sq_file, ds_file, sq_interval, buf_size);

						System.exit(1);

					} else {
						System.err.println("-s2bw requires a input file name");
						err = true;
					}

				} else {
					System.err.println("-s2bw requires a interval number");
					err = true;
				}

			} else if (arg.equals("-d2tsw")) {
				String sq_file;
				String ds_file;
				long bw_interval = 10000;
				long bw_step = 1000;
				if (i < args.length && !args[i].startsWith("-")) {

					bw_interval = Integer.parseInt(args[i++]);

					if (i < args.length && !args[i].startsWith("-")) {
						bw_step = Integer.parseInt(args[i++]);
					} else {
						System.err.println("-d2tsw requires a time step nubmber");
						err = true;
						continue;
					}
					String dest = args[i++];
					if(dest.equals("none"))dest=null;
					
					if (i < args.length && !args[i].startsWith("-")) {

						sq_file = (args[i++]);
						ds_file = sq_file + "_BWT.txt";

						if (i < args.length && !args[i].startsWith("-")) {
							ds_file = args[i++];

						}

						dl2TSW(sq_file, ds_file, bw_interval, bw_step, dest);

						System.exit(1);

					} else {
						System.err.println("-d2tsw requires a input file name");
						err = true;
					}

				} else {
					System.err.println("-d2tsw requires a time interval number");
					err = true;
				}

			} else if (arg.equals("-s2bwt")) {
				String sq_file;
				String ds_file;
				int buf_size = 512;
				long bw_interval = 10000;
				long bw_step = 1000;
				if (i < args.length && !args[i].startsWith("-")) {

					bw_interval = Integer.parseInt(args[i++]);

					if (i < args.length && !args[i].startsWith("-")) {
						bw_step = Integer.parseInt(args[i++]);
					} else {
						System.err.println("-s2bwt requires a time step nubmber");
						err = true;
						continue;
					}

					if (i < args.length && !args[i].startsWith("-")) {

						sq_file = (args[i++]);
						ds_file = sq_file + "_BWT.txt";

						if (i < args.length && !args[i].startsWith("-")) {
							ds_file = args[i++];

						}

						if (i < args.length && !args[i].startsWith("-")) {
							buf_size = Integer.parseInt(args[i++]);
						}

						sq2BW_TSW(sq_file, ds_file, bw_interval, bw_step, buf_size);

						System.exit(1);

					} else {
						System.err.println("-s2bwt requires a input file name");
						err = true;
					}

				} else {
					System.err.println("-s2bwt requires a time interval number");
					err = true;
				}

			} else if (arg.equals("-smd")) {
				String delay_file;
				String ds_file;
				int sq_interval = 50;
				int rcvr = 0;
				if ((i + 1) < args.length && !args[i].startsWith("-")) {

					sq_interval = Integer.parseInt(args[i++]);
					rcvr = Integer.parseInt(args[i++]);

					if (i < args.length && !args[i].startsWith("-")) {

						delay_file = (args[i++]);
						ds_file = "sm_" + rcvr + "_" + delay_file;

						if (i < args.length && !args[i].startsWith("-")) {
							ds_file = args[i++];

						}

						smoothDelay(delay_file, ds_file, sq_interval, rcvr);

						System.exit(1);

					} else {
						System.err.println("-smd requires a input file name");
						err = true;
					}

				} else {
					System.err.println("-s2d requires a interval number");
					err = true;
				}

			} else {
				System.err.println("Invalid argument: " + arg);
				System.exit(1);
			}
		}

		if (err) {
			System.exit(1);
		}

		if (bufsize != 0)
			Params.setBufSize(bufsize);
		if (numbuf != 0)
			Params.setNumBuf(numbuf);
		if (port != 0)
			Params.setPort(port);
		if (tr == false)
			Params.setTR(tr);
		if (!host.equals(""))
			Params.setHost(host);
		if (!maddr.equals(""))
			Params.setMCASTAddr(maddr);

		Params.setStop(stop);
		Params.setLogFile(logfile);
		Params.setEventFile(eventfile);
		Params.setInterceptFile(intercptfile);
		Params.setSeqFile(seqfile);
		Params.setBWFile(bwfile);
		Params.setBWPeriod(bw_period);
		Params.setDelayFile(delayfile);

		Params.setRepeatTime(repeatTime);

		Params.setProtocol(prot);

		Params.setRate(start_rate, end_rate, rate_step);
		
		Params.FixKey=fixKey;

		Trans = new TransThread(Params);
		//Trans.overrides = readOverrides(overrides_file);

		//Trans.setPriority(Thread.NORM_PRIORITY);

		if (monitor) {
			//transmission started by the monitor
			startMonitorMode(Trans, rsfile);

		}

		if (monitor && !tr) {
			String logheader = "" + (new Date()) + "\n" + Params.getFormatedStatsHeader();
			Trans.saveStatsToFile(logheader);

			try{
				
			if (prot == ParamsClass.OVERLAY){
				Trans.initOLSocket(Trans);
			}
			
			}catch (Throwable e){
				e.printStackTrace();
				System.out.print(e.toString());
			}
			while (true) {
				try {
					Thread.sleep(10000);
				} catch (InterruptedException e) {
				}
			}
		} else {
			Thread th = new Thread(Trans);
			th.start();

			// Wait for thread to die, then display transfer stats

			while (th.isAlive()) {
				try {
					Thread.sleep(1000L);
				} catch (InterruptedException e) {
				}
			}
		}
		//System.out.println (Params.getStats ());
		System.exit(0);
	}
	String overrides_file = "ttcp_overrides.txt";
	public String readOverrides(String propfile) {
		String overrides = "";
		
		BufferedReader input = null;
		
		if(propfile==null)return overrides;
		
		try {
			input = new BufferedReader(new FileReader(propfile));

			overrides = input.readLine();
			
			if (overrides == null)
				overrides = "";

			String line=input.readLine();
			while(line!=null){
				overrides=overrides+"&"+line;
				line=input.readLine();
			}
			
			System.out.println("Overrides: " + overrides);

			//output.println("\n");

		} catch (Exception e) {
			System.err.println("Can't read from " + propfile + " : " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
			} catch (Exception e) {
			}
		}

		return overrides;
	}
	public static void Usage() {
		System.out.println("Usage: java ttcp <options>");
		System.out.println("  -u         using UDP (default TCP)");
		System.out.println(
			"  -m [addr]  using Multicast (default TCP, default addr=224.228.19.79)");
		System.out.println("  -o         using Overlay ");
		System.out.println(
			"  -R <start_rate> [end_rate]       sending rate only used with UDP (default 0 (ASAP))");
		System.out.println("  -r         Receive mode");
		System.out.println("  -t <hostname or IP addr>   Transmit mode");
		System.out.println("  -l #       Buffer Size (default 512)");
		System.out.println("  -n #       Number of Buffers (default 1024)");
		System.out.println("  -p #       TCP Port Number (default 5001)");
		System.out.println("  -c [#]     Repeat # Times(default is never stop)");
		System.out.println(
			"  -f [file]  Log Statistics Result (default file=ttcp_log_<timestamp>.txt)");
		System.out.println(
			"  -s [file]  Record Sequence Number (default file=ttcp_seq_<timestamp>.txt)");
		System.out.println(
			"  -bw <interval> [file]  Record the Bandwidth at every <interval> ms time");
		System.out.println(
			"  -s2d <interval> <sq_file> [output_file] Convert the sequence number file to density file");
		System.out.println("  -d <delay_file>");
		System.out.println(
			"  -smd <interval> <receiver ID> <delay_file> [output_file] Smooth delay file");
		System.out.println("  -monitor   Start in Monitor Mode");
		System.out.println(
			"  -prop <file>       specify the the config file to create overlay socket");
		System.out.println("  -h         Print this message");

	}

	/** sliding window with time as X*/
	static void sq2BW_TSW(
		String sq_file,
		String bw_file,
		long bw_interval,
		long bw_step,
		int BufSize) {
		System.out.println(
			"Convert sequence number file <"
				+ sq_file
				+ "> to sliding window bandwidth file <"
				+ bw_file
				+ "> with interval of "
				+ bw_interval
				+ "ms"
				+ " and step of "
				+ bw_step
				+ "ms");

		BufferedReader input = null;
		PrintWriter output = null;

		Vector sw_times = new Vector();

		long sw_start = 0;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(sq_file)));
			output = new PrintWriter(new FileOutputStream(bw_file));
			output.println("Time(s)\tBW(kbps)\tBW(KBps)");

			String line = input.readLine();
			while (line != null) {

				try {
					StringTokenizer tokens = new StringTokenizer(line, "\t");

					String sqstr = tokens.nextToken();
					int seq = Integer.parseInt(sqstr);

					tokens.nextToken();
					tokens.nextToken();
					String timestr = tokens.nextToken();

					long rtime = Long.parseLong(timestr);

					if (rtime >= (sw_start + bw_interval)) {
						//a sliding window finished
						float bw = (float) 1.0 * BufSize * sw_times.size() / bw_interval;

						output.println("" + (float)sw_start/1000 + "\t" + (bw * 8) + "\t" + bw);

						sw_start += bw_step;

						while (sw_times.size() > 0) {
							long rt = ((Long) sw_times.elementAt(0)).longValue();
							if (rt < sw_start)
								sw_times.removeElementAt(0);
							else
								break;
						}

					}

					sw_times.addElement(new Long(rtime));

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}

	/** sliding window */
	static void sq2BW_SW(String sq_file, String bw_file, int sq_interval, int BufSize) {
		System.out.println(
			"Convert sequence number file <"
				+ sq_file
				+ "> to sliding window bandwidth file <"
				+ bw_file
				+ "> with interval of "
				+ sq_interval);

		BufferedReader input = null;
		PrintWriter output = null;

		int sliding_window[] = new int[sq_interval];
		long sw_time[] = new long[sq_interval];

		for (int i = 0; i < sq_interval; i++) {
			sw_time[i] = -1;
			sliding_window[i] = 0;
		}
		int sw_start = 0;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(sq_file)));
			output = new PrintWriter(new FileOutputStream(bw_file));
			output.println("Seq\tBW(kbps)\tBW(KBps)");

			int last_seq = -1;
			int seq_count = 0;
			long last_time = 0;

			String line = input.readLine();
			while (line != null) {

				try {
					StringTokenizer tokens = new StringTokenizer(line, "\t");

					String sqstr = tokens.nextToken();
					int seq = Integer.parseInt(sqstr);

					tokens.nextToken();
					tokens.nextToken();
					String timestr = tokens.nextToken();

					long rtime = Long.parseLong(timestr);

					//System.out.println("seq=" + seq + " time=" + rtime);

					//System.out.println(seq);
					int dist = seq - last_seq;
					if(last_seq<0){
						last_seq = seq;
						last_time = rtime;
					}
					else if (dist > 0) {

						for (int i = 0; i < dist; i++) {
							seq_count -= sliding_window[sw_start];
							if (sw_time[sw_start] >= 0)
								last_time = sw_time[sw_start];

							if (i == dist - 1) {
								seq_count++;
								sliding_window[sw_start] = 1;
								sw_time[sw_start] = rtime;
							} else {
								sliding_window[sw_start] = 0;
								sw_time[sw_start] = -1;
							}
							sw_start++;
							if (sw_start >= sliding_window.length)
								sw_start = 0;

							int interval;
							int thisseq = last_seq + i + 1;

							if (rtime - last_time > 0) {

								float bw = ((float) seq_count * BufSize) / (rtime - last_time);

								output.println((thisseq - 1) + "\t" + (bw * 8) + "\t" + bw);
							}

						}

						last_seq = seq;

					}

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}
	/** sliding window with time as X*/
	static void dl2TSW(
		String dl_file,
		String dl_tsw_file,
		long dl_interval,
		long dl_step,
		String dst) {
		System.out.println(
			"Convert delay file <"
				+ dl_file
				+ "> to time sliding window file <"
				+ dl_tsw_file
				+ "> with interval of "
				+ dl_interval
				+ "ms"
				+ " and step of "
				+ dl_step
				+ "ms");

		BufferedReader input = null;
		PrintWriter output = null;

		Vector sw_times = new Vector();
		Vector rtts= new Vector();
		long total_rtt=0;

		long sw_start = 0;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(dl_file)));
			output = new PrintWriter(new FileOutputStream(dl_tsw_file));
			output.println("Time(s)\tRTT(ms)");

			String line = input.readLine();
			while (line != null) {

				try {
					
					StringTokenizer tokens = new StringTokenizer(line, "\t");
					String dest = tokens.nextToken();

					String sqstr = tokens.nextToken();
					int seq = Integer.parseInt(sqstr);

					tokens.nextToken();
					long stime=Long.parseLong(tokens.nextToken());
					tokens.nextToken();
					tokens.nextToken();

					String timestr = tokens.nextToken();

					long rtt = Long.parseLong(timestr);
					
					
					//System.out.println("Sent "+stime+" RTT "+rtt);
					
					/*
					StringTokenizer tokens = new StringTokenizer(line, "\t");

					String sqstr = tokens.nextToken();
					int seq = Integer.parseInt(sqstr);

					tokens.nextToken();
					tokens.nextToken();
					String timestr = tokens.nextToken();

					long rtime = Long.parseLong(timestr);
					*/

					if (stime >= (sw_start + dl_interval)) {
						//a sliding window finished
						//float bw = (float) 1.0 * BufSize * sw_times.size() / dl_interval;
						float avg_rtt=0;
						
						if(sw_times.size()>0)
							avg_rtt=(float)total_rtt/sw_times.size();

						output.println("" + (float)sw_start/1000 + "\t" + avg_rtt);

						sw_start += dl_step;

						while (sw_times.size() > 0) {
							long rt = ((Long) sw_times.elementAt(0)).longValue();
							if (rt < sw_start){
								sw_times.removeElementAt(0);
								total_rtt-=((Long)rtts.elementAt(0)).longValue();
								rtts.removeElementAt(0);
							}else
								break;
						}

					}
					total_rtt+=rtt;
					sw_times.addElement(new Long(stime));
					rtts.addElement(new Long(rtt));

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}

	static void dl2SW(String dl_file, String dl_sw_file, int sq_interval, String dst) {
		System.out.println(
			"Convert delay file <"
				+ dl_file
				+ "> to sliding window delay file <"
				+ dl_sw_file
				+ "> with interval of "
				+ sq_interval);

		BufferedReader input = null;
		PrintWriter output = null;

		long sliding_window[] = new long[sq_interval];
		for (int i = 0; i < sq_interval; i++)
			sliding_window[i] = 0;
		int sw_start = 0;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(dl_file)));
			output = new PrintWriter(new FileOutputStream(dl_sw_file));
			output.println("Seq\tRTT(ms)");

			int last_seq = -1;
			long rtt_total = 0;
			int seq_count =0;
			float last_rtt =0;

			String line = input.readLine();
			while (line != null) {

				try {

					StringTokenizer tokens = new StringTokenizer(line, "\t");
					String dest = tokens.nextToken();

					String sqstr = tokens.nextToken();
					int seq = Integer.parseInt(sqstr);

					tokens.nextToken();
					tokens.nextToken();
					tokens.nextToken();
					tokens.nextToken();

					String timestr = tokens.nextToken();

					long rtt = Long.parseLong(timestr);

					if (dst != null) {
						if (!dst.equals(dest))
							continue;
						//not this receiver
					}

					//System.out.println(seq);
					int dist = seq - last_seq;
					if (dist > 0) {

						for (int i = 0; i < dist; i++) {
							rtt_total -= sliding_window[sw_start];
							if(sliding_window[sw_start]>0)seq_count--;
							
							if (i == dist - 1) {
								rtt_total += rtt;
								sliding_window[sw_start] = rtt;
								seq_count++; 
							} else
								sliding_window[sw_start] = 0;

							sw_start++;
							if (sw_start >= sliding_window.length)
								sw_start = 0;

							int interval;
							int thisseq = last_seq + i + 1;
							if (thisseq >= (sq_interval - 1))
								interval = sq_interval;
							else
								interval = seq + 1;

							float avg_rtt;
							if(seq_count>0)
								avg_rtt = ((float) rtt_total) / seq_count;
							else avg_rtt=last_rtt;
							last_rtt=avg_rtt;
							
							output.println(""+(thisseq) + "\t" + avg_rtt);

						}

						last_seq = seq;

					}

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}

	/** sliding window */
	static void sq2Ds_SW(String sq_file, String ds_file, int sq_interval) {
		System.out.println(
			"Convert sequence number file <"
				+ sq_file
				+ "> to sliding window loss rate file <"
				+ ds_file
				+ "> with interval of "
				+ sq_interval);

		BufferedReader input = null;
		PrintWriter output = null;

		int sliding_window[] = new int[sq_interval];
		for (int i = 0; i < sq_interval; i++)
			sliding_window[i] = 0;
		int sw_start = 0;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(sq_file)));
			output = new PrintWriter(new FileOutputStream(ds_file));
			output.println("Seq\tDelivery Rate\tLoss Rate");

			int last_seq = -1;
			int seq_count = 0;

			String line = input.readLine();
			while (line != null) {

				int index = line.indexOf("\t");

				try {
					int seq = Integer.parseInt(line.substring(0, index));

					//System.out.println(seq);
					int dist = seq - last_seq;
					if (dist > 0) {

						for (int i = 0; i < dist; i++) {
							seq_count -= sliding_window[sw_start];
							if (i == dist - 1) {
								seq_count++;
								sliding_window[sw_start] = 1;
							} else
								sliding_window[sw_start] = 0;

							sw_start++;
							if (sw_start >= sliding_window.length)
								sw_start = 0;

							int interval;
							int thisseq = last_seq + i + 1;
							if (thisseq >= (sq_interval - 1))
								interval = sq_interval;
							else
								interval = seq + 1;

							float sd = ((float) seq_count) / interval;
							output.println((thisseq - 1) + "\t" + sd + "\t" + (1 - sd));

						}

						last_seq = seq;

					}

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}

	static void sq2Ds(String sq_file, String ds_file, int sq_interval) {
		System.out.println(
			"Convert sequence number file <"
				+ sq_file
				+ "> to density file <"
				+ ds_file
				+ "> with interval of "
				+ sq_interval);

		BufferedReader input = null;
		PrintWriter output = null;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(sq_file)));
			output = new PrintWriter(new FileOutputStream(ds_file));
			output.println("Seq\tDensity\tLoss Ratio");

			int start_seq = 0;
			int seq_count = 0;

			String line = input.readLine();
			while (line != null) {

				int index = line.indexOf("\t");

				try {
					int seq = Integer.parseInt(line.substring(0, index));

					//System.out.println(seq);

					while ((seq - start_seq) >= sq_interval) {

						//System.err.println("seq="+seq+" start="+start_seq+" count="+seq_count);

						float sd = ((float) seq_count) / sq_interval;

						output.println(start_seq + "\t" + sd + "\t" + (1 - sd));

						start_seq += sq_interval;
						seq_count = 0;
					}

					seq_count++;

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}
	static void sq2Gap(String sq_file, String gap_file) {
		System.out.println(
			"Convert sequence number file <"
				+ sq_file
				+ "> to gap file <"
				+ gap_file);

		BufferedReader input = null;
		PrintWriter output = null;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(sq_file)));
			output = new PrintWriter(new FileOutputStream(gap_file));
			output.println("Start Seq\tGap Length");

			int last_seq=-1;
			
			
			String line = input.readLine();
			while (line != null) {

				int index = line.indexOf("\t");

				try {
					int seq = Integer.parseInt(line.substring(0, index));

					//System.out.println(seq);
					if((seq-last_seq)>1){
						int gap=seq-last_seq -1;
						output.println(""+(last_seq+1)+"\t"+gap);
						for(int i=last_seq+2;i<=seq;i++){
							output.println(""+i+"\t"+0);
						}
						
					}else{
						output.println(""+seq+"\t"+0);
					}
					last_seq=seq;

					

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}


	static void smoothDelay(String delay_file, String ds_file, int sq_interval, int _rcvr) {
		System.out.println(
			"Smooth delay file <"
				+ delay_file
				+ "> to file <"
				+ ds_file
				+ "> with interval of "
				+ sq_interval
				+ " for receiver "
				+ _rcvr);

		BufferedReader input = null;
		PrintWriter output = null;

		try {
			input = new BufferedReader(new InputStreamReader(new FileInputStream(delay_file)));
			output = new PrintWriter(new FileOutputStream(ds_file));
			output.println("Receiver\tSeq\tAvgDelay");

			int start_seq = 0;
			int seq_count = 0;
			int sum_delay = 0;

			String line = input.readLine();
			while (line != null) {

				int index1 = line.indexOf("\t"); //first
				int index2 = line.indexOf("\t", index1 + 1); //second
				int delay_index = line.indexOf("\t", index2 + 1); //3rd
				delay_index = line.indexOf("\t", delay_index + 1); //4th
				delay_index = line.indexOf("\t", delay_index + 1); //5th
				int delay_end_index = line.indexOf("\t", delay_index + 1); //6th

				try {
					int rcvr = Integer.parseInt(line.substring(0, index1));
					int seq = Integer.parseInt(line.substring(index1 + 1, index2));
					int delay = Integer.parseInt(line.substring(delay_index + 1, delay_end_index));
					//System.out.println("rcvr="+rcvr+" seq="+seq+" delay="+delay);

					if (rcvr != _rcvr) {
						line = input.readLine();
						continue;
					}

					while ((seq - start_seq) >= sq_interval) {

						//System.err.println("seq="+seq+" start="+start_seq+" count="+seq_count);

						float avg_delay = ((float) sum_delay) / seq_count;

						output.println(rcvr + "\t" + start_seq + "\t" + avg_delay);

						start_seq += sq_interval;
						seq_count = 0;
						sum_delay = 0;
					}

					seq_count++;
					sum_delay += delay;

				} catch (Exception e) {
				}

				line = input.readLine();
			}

		} catch (Exception e) {
			System.err.println("Can't open file: " + e.toString());

		} finally {
			try {
				if (input != null)
					input.close();
				if (output != null)
					output.close();
			} catch (Exception e) {

				System.err.println("Can't close file: " + e.toString());
			}

		}

	}

	

}
